Question:

A peak element is an element that is greater than its neighbors.

Given an input array nums, where nums[i] ≠ nums[i+1], find a peak element and return its index.

The array may contain multiple peaks, in that case return the index to any one of the peaks is fine.

You may imagine that nums[-1] = nums[n] = -∞.

Example 1:

Input: nums = [1,2,3,1]
Output: 2
Explanation: 3 is a peak element and your function should return the index number 2.

Example 2:

Input: nums = [1,2,1,3,5,6,4]
Output: 1 or 5
Explanation: Your function can return either index number 1 where the peak element is 2,
             or index number 5 where the peak element is 6.

Note:

  • Your solution should be in logarithmic complexity.

Thinking:

  • Method1:
class Solution {
    public int findPeakElement(int[] nums) {
        int len = nums.length;
        if(len == 1) return 0;
        if(nums[0] > nums[1]) return 0;
        for(int i = 1; i < len - 1; i++){
            if(nums[i] > nums[i - 1] && nums[i] > nums[i + 1])
                return i;
        }
        if(nums[len - 1] > nums[len - 2])
            return len - 1;
        return -1;
    }
}

二刷

  1. O(N),可以AC,无法满足题意。
    class Solution {
     public int findPeakElement(int[] nums) {
         if(nums.length == 1) return 0;
         if(nums.length == 2){
             return nums[0] > nums[1] ? 0 : 1;
         }
         int i = 0;
         if(nums[i] > nums[i + 1]) return 0;
         for(i = 1; i < nums.length - 1; i++){
             if(nums[i] > nums[i - 1] && nums[i] > nums[i + 1]) return i;
         }
         if(i > 0 && nums[i] > nums[i - 1]) return i;
         return -1;
     }
    }
    
  2. 要满足题意的方法,我们使用二分法。因为左右两侧的数可以理解为负无穷,所以我们判断nums[mid]和nums[mid + 1]。如果nums[mid + 1]>nums[mid],则说明峰值一定出现在左侧。具体原因参考reference中的链接。
    class Solution {
     public int findPeakElement(int[] nums) {
         int low = 0, high = nums.length - 1, mid = 0;
         while(low < high){
             mid = low + (high - low) / 2;
             if(nums[mid] < nums[mid + 1]) low = mid + 1;
             else high = mid;
         }
         return low;
     }
    }
    

Reference

  1. [leetcode 162. Find Peak Element-查找峰元素 二分查找](https://blog.csdn.net/happyaaaaaaaaaaa/article/details/51590056)